
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "stl.h"

void	CalcNormal(x0,y0,z0,x1,y1,z1,x2,y2,z2,nx,ny,nz)
double	x0,y0,z0,x1,y1,z1,x2,y2,z2,*nx,*ny,*nz;
{
	double	x10=x1-x0,y10=y1-y0,z10=z1-z0,
		x20=x2-x0,y20=y2-y0,z20=z2-z0,
		x=y10*z20-z10*y20,
		y=z10*x20-x10*z20,
		z=x10*y20-y10*x20,s=sqrt(x*x+y*y+z*z);

	*nx=x/s; *ny=y/s; *nz=z/s;
}

#define File	(stl->file)
#define Type	(stl->type)
#define Chr	(stl->u.a.chr)
#define Pos	(stl->u.a.pos)
#define Str	(stl->u.a.str)
#define Cnt	(stl->u.b.cnt)
#define Num	(stl->u.b.num)
#define Fread	(stl->u.b.fread)

static int	fGetC(stl)
STL		*stl;
{
	return Chr=(Pos<80)?(int)Str[Pos++]:fgetc(File);
}

#define LOWER_CASE(chr)	(chr>='A' && chr<='Z')?chr|32:chr

static int	GetStr(stl)
STL		*stl;
{
	char	*str=Str;

	while (fGetC(stl)==' ' || Chr=='\t'
			       || Chr=='\r'
			       || Chr=='\n'); if (Chr==EOF) return 0;

	do {
	    *(str++)=LOWER_CASE(Chr); if (str==Str+80) return 0;
	} while (fGetC(stl)!=' ' && Chr!='\t'
				 && Chr!='\r'
				 && Chr!='\n' && Chr!=EOF); *str='\0'; return 1;
}

static size_t	fRead(ptr,size,items,file)
char		*ptr;
size_t		size,items;
FILE		*file;
{
	size_t	item,size1=size-1,read=fread(ptr,size,items,file);
        char	*c1,*c2,c;

	for (item=0; item<read; item++) {
	    for (c2=(c1=ptr)+size1; c1<c2; c1++, c2--) {
		c=(*c1); *c1=(*c2); *c2=c;
	    }
	    ptr+=size;
	}
	return read;
}

#define GET_CMP(str,val)	if (!GetStr(stl) || strcmp(Str,str)) return val

int	SetUpSTL(stl,file)
STL	*stl;
FILE	*file;
{
	int	pos;

	if (fread(Str,1,80,File=file)!=80) return 0;

	for (pos=0; pos<80; pos++) if (Str[pos]=='\0') break;

	if (pos<80)
	    Type=STL_TYPE_BINARY;
	else {
	    for (pos=0; pos<80-5; pos++)
		if (Str[pos]!=' ' && Str[pos]!='\t'
				  && Str[pos]!='\r'
				  && Str[pos]!='\n') break;

	    for (Pos=pos; Pos<pos+5; Pos++) Str[Pos]=LOWER_CASE(Str[Pos]);

	    Type=(strncmp(Str+pos,"solid",5))?STL_TYPE_BINARY:STL_TYPE_ASCII;
	}
	if (Type==STL_TYPE_ASCII) {
	    while (fGetC(stl)!='\n') if (Chr==EOF) return 0;
	}
	else {
	    Cnt=0;
{
	    short	word=0x1234;
	    char	*byte=(char *)&word;

	    Fread=(*byte==(char)(word&0xff))?fread:fRead;
}
	    if ((*Fread)((char *)&Num,sizeof(Num),1,File)!=1) return 0;
	}
	return 1;
}

#define GET_F(f)	if (!GetStr(stl)) return -1; f=atof(Str)

#ifdef	STL_COLOR
int	ScanSTL(stl,x0,y0,z0,x1,y1,z1,x2,y2,z2,flag)
#else
int	ScanSTL(stl,x0,y0,z0,x1,y1,z1,x2,y2,z2)
#endif
STL	*stl;
float	*x0,*y0,*z0,*x1,*y1,*z1,*x2,*y2,*z2;
#ifdef	STL_COLOR
short	*flag;
#endif
{
	float	x,y,z;
#ifndef	STL_COLOR
	short	f,*flag=(&f);
#endif
	double	nx,ny,nz;

	switch(Type) {
	    case STL_TYPE_ASCII:
		if (!GetStr(stl)) return -1;

		if (!strcmp(Str,"endsolid")) {
		    while (Chr!='\n' && Chr!=EOF) (void)fGetC(stl); return 0;
		}
		if (strcmp(Str,"facet")) return -1;

		GET_CMP("normal",-1); GET_F(x); GET_F(y); GET_F(z);
		GET_CMP("outer",-1);
		GET_CMP("loop",-1);
		GET_CMP("vertex",-1); GET_F(*x0); GET_F(*y0); GET_F(*z0);
		GET_CMP("vertex",-1); GET_F(*x1); GET_F(*y1); GET_F(*z1);
		GET_CMP("vertex",-1); GET_F(*x2); GET_F(*y2); GET_F(*z2);
		GET_CMP("endloop",-1);
		GET_CMP("endfacet",-1);
#ifdef	STL_COLOR
		*flag=0;
#endif
		break;
	    case STL_TYPE_BINARY:
		if (Cnt==Num) return 0;

		++Cnt;

		if ((*Fread)((char *)&x,sizeof(x),1,File)!=1 ||
		    (*Fread)((char *)&y,sizeof(y),1,File)!=1 ||
		    (*Fread)((char *)&z,sizeof(z),1,File)!=1 ||
		    (*Fread)((char *)x0,sizeof(*x0),1,File)!=1 ||
		    (*Fread)((char *)y0,sizeof(*y0),1,File)!=1 ||
		    (*Fread)((char *)z0,sizeof(*z0),1,File)!=1 ||
		    (*Fread)((char *)x1,sizeof(*x1),1,File)!=1 ||
		    (*Fread)((char *)y1,sizeof(*y1),1,File)!=1 ||
		    (*Fread)((char *)z1,sizeof(*z1),1,File)!=1 ||
		    (*Fread)((char *)x2,sizeof(*x2),1,File)!=1 ||
		    (*Fread)((char *)y2,sizeof(*y2),1,File)!=1 ||
		    (*Fread)((char *)z2,sizeof(*z2),1,File)!=1 ||
		    (*Fread)((char *)flag,sizeof(*flag),1,File)!=1) return -1;

		break;
	    default:
		return -1;
	}
	CalcNormal((double)*x0,(double)*y0,(double)*z0,
		   (double)*x1,(double)*y1,(double)*z1,
		   (double)*x2,(double)*y2,(double)*z2,&nx,&ny,&nz);
	if (nx*x+ny*y+nz*z<0.0) {
	    x=(*x1); *x1=(*x2); *x2=x;
	    y=(*y1); *y1=(*y2); *y2=y;
	    z=(*z1); *z1=(*z2); *z2=z;
	}
	return 1;
}

#ifdef	STL_COLOR
Facet	*AllocFacet(x0,y0,z0,x1,y1,z1,x2,y2,z2,flag)
#else
Facet	*AllocFacet(x0,y0,z0,x1,y1,z1,x2,y2,z2)
#endif
float	x0,y0,z0,x1,y1,z1,x2,y2,z2;
#ifdef	STL_COLOR
short	flag;
#endif
{
	Facet	*facet=(Facet *)malloc(sizeof(Facet));

	if (facet!=NULL) {
	    facet->x0=x0; facet->y0=y0; facet->z0=z0;
	    facet->x1=x1; facet->y1=y1; facet->z1=z1;
	    facet->x2=x2; facet->y2=y2; facet->z2=z2;
#ifdef	STL_COLOR
	    facet->flag=flag;
#endif
	    facet->next=NULL;
	}
	return facet;
}

Facet	*ReadFacet(file)
FILE	*file;
{
	STL	stl;
	float	x0,y0,z0,x1,y1,z1,x2,y2,z2;
#ifdef	STL_COLOR
	short	flag;
#endif
	Facet	*facet=NULL,**ptr=(&facet);

	if (!SetUpSTL(&stl,file)) return NULL;

#ifdef	STL_COLOR
	while (ScanSTL(&stl,&x0,&y0,&z0,&x1,&y1,&z1,&x2,&y2,&z2,&flag)>0 &&
	      (*ptr=AllocFacet(x0,y0,z0,x1,y1,z1,x2,y2,z2,flag))!=NULL)
#else
	while (ScanSTL(&stl,&x0,&y0,&z0,&x1,&y1,&z1,&x2,&y2,&z2)>0 &&
	      (*ptr=AllocFacet(x0,y0,z0,x1,y1,z1,x2,y2,z2))!=NULL)
#endif
	    ptr=(&((*ptr)->next));

	return facet;
}
