
#include <stdio.h>
#include <stdlib.h>
#include <string.h>	/* using strcmp() */

#define INT_WID	((1<<28)-1)	/* must be less than 1<<28 */

extern void	Error(char *msg),
		chull3_(/* ... */);

static void	GetN(FILE *file,char *ptr)
{
	if (fread(ptr,(size_t)4,(size_t)1,file)!=1) Error("data read error.");
}

static void	GetR(FILE *file,char *ptr)
{
	char	c[4];

	GetN(file,c); ptr[3]=c[0]; ptr[2]=c[1]; ptr[1]=c[2]; ptr[0]=c[3];
}

static int	FV3(int *X,int *Y,int *Z,
		    int *fe,int *sv,int *ev,int *rf,int *sce,int *ece, int f,
		    int *v1,int *v2,int *v3)
{
	int		e=fe[f]-1;
	long long	x1,y1,z1,x2,y2,z2;

	if (f==rf[e]-1) {
	    *v1=ev[e]-1; *v2=sv[e]-1; e=sce[e]-1;
	}
	else {
	    *v1=sv[e]-1; *v2=ev[e]-1; e=ece[e]-1;
	}
	*v3=(f==rf[e]-1)?sv[e]-1:ev[e]-1;

	return (x1=X[*v1]-X[*v3])*(y2=Y[*v2]-Y[*v3])!=
	       (y1=Y[*v1]-Y[*v3])*(x2=X[*v2]-X[*v3]) ||
	       (z1=Z[*v1]-Z[*v3])*x2!=x1*(z2=Z[*v2]-Z[*v3]) || y1*z2!=z1*y2;
}

static void	PutN(FILE *file,char *ptr)
{
	(void)fwrite(ptr,(size_t)4,(size_t)1,file);
}

static void	PutR(FILE *file,char *ptr)
{
	char	c[4];

	c[0]=ptr[3]; c[1]=ptr[2]; c[2]=ptr[1]; c[3]=ptr[0]; PutN(file,c);
}

int	main(int argc,char **argv)
{
	FILE	*file;
	int	V,F,N1,N2,N3,i,v1,v2,v3,
		*x,*y,*z,*name,para[10],
		*ve,*fe,*sv,*ev,*rf,*lf,*sce,*scce,*ece,*ecce,
		*wv1,*wv2,*wv3,*wv4,*wv5,*wv6,*we1,*we2,*wf1,*wf2;
	char	e_h[12];
	float	*X,*Y,*Z;
	double	a,b;

	void	(*Get)(),(*Put)();
{
	short	s=1;
	char	*c=(char *)&s;

	if ((short)*c==s) {
	    Get=GetN; Put=PutN;
	}
	else {
	    Get=GetR; Put=PutR;
	}
}
	if (argc!=3) Error("usage : zcp_ch orgZCP newZCP");

	if (argv[1][0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(argv[1],"rb"))==NULL) Error("file not found.");

	if (fscanf(file,"ply\n"
			"format binary_little_endian 1.0\n"
			"element vertex %d\n"
			"property float x\n"
			"property float y\n"
			"property float z\n"
			"element face %d\n"
			"property uchar red\n"
			"property uchar green\n"
			"property uchar blue\n"
			"property list uchar int vertex_indices\n",&V,&F)!=2 ||
	    fgets(e_h,12,file)==NULL || strcmp(e_h,"end_header\n") ||
	    V<=0 || F<=0) Error("bad header.");

	N1=V+1; N2=N1*3; N3=N1*4;

#define M0(X)	(X=(float *)malloc(sizeof(float)*V))==NULL
#define M1(x)	(x=(int *)malloc(sizeof(int)*N1))==NULL
#define M2(fe)	(fe=(int *)malloc(sizeof(int)*N2))==NULL
#define M3(sv)	(sv=(int *)malloc(sizeof(int)*N3))==NULL

	if (M0(X) || M0(Y) || M0(Z) ||
	    M1(x) || M1(y) || M1(z) || M1(name) ||
	    M1(ve) || M2(fe) || M3(sv) || M3(ev) || M3(rf) || M3(lf) ||
	    M3(sce) || M3(scce) || M3(ece) || M3(ecce) ||
	    M1(wv1) || M1(wv2) || M1(wv3) || M1(wv4) || M1(wv5) || M1(wv6) ||
	    M3(we1) || M3(we2) ||
	    M2(wf1) || M2(wf2)) Error("memory allocation error.");

	for (i=0; i<V; i++) {
	    (*Get)(file,X+i);
	    (*Get)(file,Y+i);
	    (*Get)(file,Z+i);

	    if (i==0) a=b=X[0]; else
	    if (X[i]<a) a=X[i]; else if (X[i]>b) b=X[i];
	    if (Y[i]<a) a=Y[i]; else if (Y[i]>b) b=Y[i];
	    if (Z[i]<a) a=Z[i]; else if (Z[i]>b) b=Z[i];
	}
	if (file!=stdin) (void)fclose(file);

	b=(double)(2*INT_WID)/(b-a); a=0.5-a*b;
	for (i=0; i<V; i++) {
	    x[i]=(int)(X[i]*b+a)-INT_WID;
	    y[i]=(int)(Y[i]*b+a)-INT_WID;
	    z[i]=(int)(Z[i]*b+a)-INT_WID; name[i]=i;
	}
	para[0]=N1; chull3_(&V,x,y,z,name,para,
			    ve,fe,sv,ev,rf,lf,sce,scce,ece,ecce,
			    wv1,wv2,wv3,wv4,wv5,wv6,we1,we2,wf1,wf2);

	if (argv[2][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[2],"wb"))==NULL) Error("file not stored.");

	V=0;
	for (i=0; i<N1; i++) {
	    name[i]=V; V+=wv5[i];
	}
	F=0;
	for (i=0; i<N2; i++)
	    F+=(wf1[i] && FV3(x,y,z,fe,sv,ev,rf,sce,ece,i,&v1,&v2,&v3));

	(void)fprintf(file,"ply\n"
			   "format binary_little_endian 1.0\n"
			   "element vertex %d\n"
			   "property float x\n"
			   "property float y\n"
			   "property float z\n"
			   "element face %d\n"
			   "property uchar red\n"
			   "property uchar green\n"
			   "property uchar blue\n"
			   "property list uchar int vertex_indices\n"
			   "end_header\n",V,F);

	for (i=0; i<N1; i++)
	    if (wv5[i]) {
		(*Put)(file,X+i);
		(*Put)(file,Y+i);
		(*Put)(file,Z+i);
	    }

	for (i=0; i<N2; i++)
	    if (wf1[i] && FV3(x,y,z,fe,sv,ev,rf,sce,ece,i,&v1,&v2,&v3)) {

#define PUTC(file,code)	(void)fputc(code,file)

		PUTC(file,255);
		PUTC(file,255);
		PUTC(file,255); PUTC(file,3); (*Put)(file,name+v1);
					      (*Put)(file,name+v2);
					      (*Put)(file,name+v3);
	    }

	if (file!=stdout) (void)fclose(file);

	free(wf2); free(wf1);
	free(we2); free(we1);
	free(wv6); free(wv5); free(wv4); free(wv3); free(wv2); free(wv1);
	free(ecce); free(ece); free(scce); free(sce);
	free(lf); free(rf); free(ev); free(sv); free(fe); free(ve);
	free(name); free(z); free(y); free(x);
	free(Z); free(Y); free(X);

	return 0;
}
